﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace PhysXTanks.Entities
{
    class Tank
    {
        private Vector3 position;
        private Matrix pose;
        private int hitPoints;     

        public Tank(Vector3 position)
        {
            this.position.X = position.X;
            this.position.Y = position.Y;
            this.position.Z = position.Z;
            this.hitPoints = 100;
        }
        public Tank(Matrix pose)
        {
            this.pose.M11 = pose.M11;
            this.pose.M12 = pose.M12;
            this.pose.M13 = pose.M13;
            this.pose.M14 = pose.M14;
            this.pose.M21 = pose.M21;
            this.pose.M22 = pose.M22;
            this.pose.M23 = pose.M23;
            this.pose.M24 = pose.M24;
            this.pose.M31 = pose.M31;
            this.pose.M32 = pose.M32;
            this.pose.M33 = pose.M33;
            this.pose.M34 = pose.M34;
            this.pose.M41 = pose.M41;
            this.pose.M42 = pose.M42;
            this.pose.M43 = pose.M43;
            this.pose.M44 = pose.M44;
        }
        public Tank()
        {
            this.position.X = 0.0f;
            this.position.Y = 0.0f;
            this.position.Z = 0.0f;
            this.hitPoints = 100;
        }

        public virtual void Hit(int damage)
        {
            if (this.hitPoints > 0)
            {
                this.hitPoints -= damage;
            }
            if (hitPoints <= 0.0f)
            {
                Console.WriteLine("You are dead bro");
            }
        }

        public Vector3 Position
        {
            get
            {
                return this.position;
            }
            set
            {
                this.position = value;
            }
        }

        public Matrix Pose
        {
            get
            {
                return this.pose;
            }
            set
            {
                this.pose = value;
            }
        }

        public int HitPoints
        {
            get
            {
                return this.hitPoints;
            }
            set
            {
                this.hitPoints = value;
            }
        }
    }
}
